{$IFNDEF VER60}
{$A+,B+,F-,G+,I-,O+,P+,Q-,R-,S-,T-,V-,X+,Y-}
{$ELSE}
{$A+,B+,F-,G+,I-,O+,R-,S-,V-,X+}
{$ENDIF}
uses crt,soundlib;
var
  olvol,vol : array[0..1] of word;
  i         : integer;
  tc,bc     : byte;
  st        : string[39];

procedure TextColor(Color: Byte);
begin
  tc := color;
  crt.textcolor(color);
end;

procedure TextBackground(Color: Byte);
begin
  bc := color;
  crt.textbackground(color);
end;

procedure writexy(x,y : integer;s : string);
var
  i : integer;
  color : word;
begin
  color := (tc+bc shl 4) shl 8;
  dec(x,2);dec(y);
  for i := 1 to length(s) do memw[segB800:(y*80+x)*2+i*2] := ord(s[i])+color;
end;

procedure frame(x,y,sx,sy : integer);
const
  frames : array[1..9] of char = ('','','','','','','','','');
var
  lx,ly : integer;
  s : string;
begin
  textcolor(white);
  textbackground(blue);
  s := frames[1];
  for lx := 1 to sx-2 do s := s + frames[5];
  s := s + frames[2];
  gotoxy(x,y);
  write(s);
  for ly := 1 to sy-2 do begin
    s := frames[7];
    for lx := 1 to sx-2 do s := s + ' ';
    s := s + frames[8];
    gotoxy(x,y+ly);
    write(s);
    textcolor(lightgray);
    textbackground(black);
    write('');
    textbackground(blue);
    textcolor(white);
  end;
  s := frames[4];
  for lx := 1 to sx-2 do s := s + frames[9];
  s := s + frames[3];
  gotoxy(x,y+sy-1);
  write(s);
  s := '';
  textcolor(lightgray);
  textbackground(black);
  write('');
  for lx := 1 to sx do s := s + '';
  gotoxy(x+2,y+sy);
  write(s);
  textbackground(blue);
end;

procedure cls;
begin
  textbackground(blue);
  textcolor(blue);
  clrscr;
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,2);
  write('');
  textcolor(lightgray);
  textbackground(black);
  write('');textcolor(lightgray);
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,3);
  for i := 1 to 22 do write('');
  textcolor(white);
  textbackground(blue);
  writexy(3,1,'Soundplayer, (c) 1997-1998 by Stefan Ghler, Germany - uses '+soundlib_vstr);
end;

procedure hidecursor;
begin
  gotoxy(1,1);
end;

procedure setchar(ch:char; var data);
begin
  portw[$03c4] := $0402;
  portw[$03c4] := $0704;
  portw[$03ce] := $0204;
  portw[$03ce] := $0005;
  portw[$03ce] := $0006;
  move(data,ptr(segA000,ord(ch) shl 5)^,16);
  portw[$03c4] := $0302;
  portw[$03c4] := $0304;
  portw[$03ce] := $0004;
  portw[$03ce] := $1005;
  portw[$03ce] := $0e06;
end;

procedure vumeter;
{This version of the vumeter works only optimal
 with CD-Quality-files. If you use files with
 a lower byterate, the vumeter won't work smooth.
 You can change this by using only sections of
 the buffer. If you wanna know more about this,
 ask me via email or look in the proggy soundem4.pas.
 This here is because to hold the program relatively
 simple and short.}
procedure showvu(x,y,size : word);
var
  i : integer;
  s : string;
begin
  s := '';
  textcolor(lightcyan);
  for i := 1 to size div 3 do s := s+ '';
  case size mod 3 of
    0 : s := s+' ';
    1 : s := s+'';
    2 : s := s+'';
  end;
  for i := size div 3 to 17 do s := s+' ';
  writexy(x,y,s);
end;

var
  sound16bit : boolean;
  playp      : pointer;

begin
  sound16bit := play.data[actfile].sound16bit;
  {$IFDEF DPMI}
  playp := ptr(play.p,0);
  {$ELSE}
  playp := play.p;
  {$ENDIF}
  asm
    db    66h;xor ax,ax
    db    66h;mov word ptr vol,ax
    les   di,playp
    cmp   play.activeblock,1
    je    @noadd
      add   di,word ptr play.blocksize
    @noadd:
    mov   si,word ptr play.blocksize
    shr   si,3
    xor   bx,bx
    xor   cx,cx
    xor   dx,dx
    @lp:
      cmp   sound16bit,0
      je    @no16
      cmp   blaster.version,sb16
      jb    @no16
      mov   al,es:[di+1]
      add   al,80h
      mov   ah,es:[di+3]
      add   ah,80h
      jmp   @is16
      @no16:
      mov   ax,es:[di]
      @is16:

      sub   ax,8080h{jeweils 128}
      or    al,al
      jns   @alns
      neg   al
      @alns:
      or    ah,ah
      jns   @ahns
      neg   ah
      @ahns:
      mov   bl,ah
      xor   ah,ah
      add   cx,ax
      add   dx,bx
      add   di,8

      dec   si
    jnz @lp
    db   66h;shl dx,16
    mov  dx,cx
    db   66h;mov word ptr vol,dx
end;


  vol[0] := vol[0] div (play.blocksize shr 3);
  if play.data[actfile].stereo then vol[1] := vol[1] div (play.blocksize shr 3);

  if vol[0] > 54 then vol[0] := 54;
  if vol[1] > 54 then vol[1] := 54;

  if olvol[0] > vol[0]+4 then begin
    dec(olvol[0],5);
    vol[0] := olvol[0];
  end else if olvol[0]+8 < vol[0] then begin
    inc(olvol[0],9);
    vol[0] := olvol[0];
  end else olvol[0] := vol[0];

  if play.data[actfile].stereo then begin
    if olvol[1] > vol[1]+4 then begin
      dec(olvol[1],5);
      vol[1] := olvol[1];
    end else if olvol[1]+8 < vol[1] then begin
      inc(olvol[1],9);
      vol[1] := olvol[1];
    end else olvol[1] := vol[1];
  end else vol[1] := vol[0];

  textbackground(black);
  showvu(10,19,vol[0]);
  showvu(10,20,vol[1]);
  textcolor(white);
  textbackground(blue);
end;

function makestr(l : longint;size : byte) : String;
{convert integer to string}
var
  s : string;
  i : integer;
begin
  str(l,s);
  for i := 1 to size-length(s) do s := '0'+s;
  makestr := s;
end;


const
  led1  : array[0..15] of byte=(0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0);
  led2  : array[0..15] of byte=(0,0,0,0,144,144,144,144,144,144,144,144,0,0,0,0);
  led3  : array[0..15] of byte=(0,0,0,0,146,146,146,146,146,146,146,146,0,0,0,0);
  char1 : array[0..15] of byte=(0,0,0,0,170,0,170,0,170,0,170,0,170,0,170,0);
  char2 : array[0..15] of byte=(0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,0);
  lo     : array[0..15] of byte=(255,255,192,192,192,192,192,192,192,192,192,192,192,192,192,192);
  ro     : array[0..15] of byte=(255,255,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  o      : array[0..15] of byte=(255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
  so     : array[0..15] of byte=(255,255,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  s      : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  lu     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,255,255);
  ru     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,255,255);
  u      : array[0..15] of byte=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255);
  su     : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,255,255);
  sr     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  sl     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192);
  volume1  : array[0..15] of byte=(126,255,255,255,255,255,255,126,24,24,24,24,24,24,24,24);
  volume2  : array[0..15] of byte=(24,24,24,24,24,24,24,24,126,255,255,255,255,255,255,126);

procedure volumebar(x,y,vol : byte;name : string;active : boolean);
var
  i,pos : integer;
begin
  if active then textcolor(white) else textcolor(lightgray);
  writexy(x-2,y-1,name);
  pos := word(vol*5) div 32;
  for i := 1 to (12-pos) div 2-1 do writexy(x,y+i-1,'');
  if (12-pos) div 2 < 2 then i := 0;
  if pos mod 2 = 1 then writexy(x,y+i,#128) else writexy(x,y+i,#127);
  if i < 6 then
  for i := (12-pos) div 2+1 to 6 do writexy(x,y+i-1,'');
  writexy(x-1,y+6,makestr(vol,3));
end;

var
  volume : array[1..4] of record
    l,r,pos : byte;
    name    : string;
  end;
  actvol   : byte;

procedure showvolbars;
begin
  for i := 1 to 4 do volumebar(volume[i].pos,5,volume[i].l,volume[i].name,actvol = i);
end;

procedure incvolume(what,incer : shortint);
var
  b : byte;
begin
  if incer > 0 then begin
    if volume[what].l < 64 then inc(volume[what].l,incer)
  end else
  if volume[what].l > 2 then inc(volume[what].l,incer);

  case what of
    1 : b := master;
    2 : b := voice;
    3 : b := bass;
    4 : b := treble;
  end;
  setvolume(b,volume[what].l-1,volume[what].l-1);
  volumebar(volume[what].pos,5,volume[what].l,volume[what].name,true);
end;

var
  lastblock   : byte;
  pos,pos2    : longint;
  ch,lch      : char;
  memsize     : word;
  oldexitproc : pointer;
  clear       : boolean;
  state       : byte;

procedure exproc;far;
begin
  exitproc := oldexitproc;
  if clear then textmode(3);
end;

begin
  oldexitproc := exitproc;
  exitproc    := @exproc;
  clear       := true;
  if paramcount = 0 then begin
    writeln('Usage: SOUNDEM2.EXE [FILE]');
    writeln('FILE : WAV or VOCfile');
    clear := false;
    exit;
  end;
  state := initblaster;
  if state <> sb_noerror then errorproc(state); { give out errormessage if error }
  setchar('',led1);
  setchar('',led2);
  setchar('',led3);
  setchar('',char1);
  setchar('',char2);
  setchar('',lo);
  setchar('',o);
  setchar('',so);
  setchar('',s);
  setchar('',ro);
  setchar('',lu);
  setchar('',ru);
  setchar('',su);
  setchar('',u);
  setchar('',sl);
  setchar('',sr);

  setchar(#127,volume1);
  setchar(#128,volume2);
  cls;
  writexy(13,25,'Take a look at my Website: http://sourcenet.home.pages.de');
  getvolume(master,volume[1].l,volume[1].r);
  getvolume(voice ,volume[2].l,volume[2].r);
  getvolume(bass  ,volume[3].l,volume[3].r);
  getvolume(treble ,volume[4].l,volume[4].r);
  volume[1].pos :=  8;
  {writexy(6,4,'Master    Voice    Bass     Treble');}
  volume[1].name:=  'Master';
  volume[2].pos := 18;
  volume[2].name:=  'Voice';
  volume[3].pos := 27;
  volume[3].name:=  'Bass';
  volume[4].pos := 36;
  volume[4].name:=  'Treble';

  actvol := 1;
  for i := 1 to 4 do volume[i].l := (volume[i].l+volume[i].r) shr 1;

  state := opensound(0,paramstr(1));
  if state <> sb_noerror then begin
    textmode(3);
    write('Error while opening file: ');
    errorproc(state);
  end;
  memsize := 1250;
  if play.data[0].sound16bit then inc(memsize,memsize);
  if play.data[0].stereo     then inc(memsize,memsize);
  if play.data[0].frequency > 22050 then inc(memsize,memsize);
  setmemsize(memsize);
  startplay(0);
  lastblock := play.activeblock;
  frame(4,3,74,10);
  for i := 5 to 10 do writexy(6,i,'-- --     -- --    -- --    -- --');
  showvolbars;

  frame(4,12,74,5);
  writexy(6,13,'P  : Pause');
  writexy(6,14,#27#26' : Move between volumebars');
  writexy(6,15,#24#25' : Change volume');
  writexy(40,13,'ESC : Exit');
  writexy(40,14,'S   : Surround on');

  frame(4,18,29,5);
  if play.data[actfile].sound16bit then writexy(6,21,'16 Bit') else writexy(6,21,' 8 Bit');
  if play.data[actfile].stereo then writexy(13,21,'Stereo') else writexy(13,21,' Mono');
  writexy(20,21,'at '+makestr(play.data[actfile].frequency,1)+' Hz');
  textbackground(black);
  writexy(6,19,'                         ');
  writexy(6,20,'                         ');
  textbackground(black);
  textcolor(white);
  writexy(8,19,'L ');
  writexy(8,20,'R ');

  frame(35,18,43,5);

  textcolor(white);
  pos := play.data[actfile].fsize - play.data[actfile].fdatastart;
  writexy(57,20,'Size    : '+makestr(pos div 1024,5)+' KB');
  pos := pos div (longint(play.data[actfile].frequency)*succ(byte(play.data[actfile].sound16bit))
         *succ(byte(play.data[actfile].stereo)));
  writexy(57,19,'Duration: '+makestr(pos div 60,2)+':'+makestr(pos mod 60,2));
  hidecursor;
  repeat

    delay(15);{that's because the function getactpos should not be called so often}
    textcolor(white);
    pos := getactpos;
    pos2 := pos;
    pos := pos div (longint(play.data[actfile].frequency)*succ(byte(play.data[actfile].sound16bit))
           *succ(byte(play.data[actfile].stereo)));
    writexy(37,19,'Time    : '+makestr(pos div 60,2)+':'+makestr(pos mod 60,2));
    writexy(37,20,'Position: '+makestr(pos2 div 1024,5)+' KB');
    st := '';
    for i := 1 to round(pos2/play.data[actfile].fsize*39)  do st := st+'';
    for i := round(pos2/play.data[actfile].fsize*39) to 38 do st := st+'';
    writexy(37,21,st);

    if lastblock <> play.activeblock then begin
      lastblock := play.activeblock;
      vumeter;
    end;
    if keypressed then begin
      lch := ch;
      ch := readkey;
      if lch = #0 then begin
        case ch of
          #72 : incvolume(actvol,2);
          #80 : incvolume(actvol,-2);
          #77 : if actvol < 4 then begin
                inc(actvol);showvolbars;end;
          #75 : if actvol > 1 then begin
                dec(actvol);showvolbars;end;
        end;
      end else begin
        if (ch = 's')or(ch = 'S') then begin
          textcolor(lightgray);
          surround := not surround;
          if surround then writexy(40,14,'S   : Surround off') else
          writexy(40,14,'S   : Surround on ');
        end;
        if (ch = 'p')or(ch = 'P') then begin
          pauseplay(not play.paused);
          if play.paused then begin
            textbackground(black);
            writexy(10,19,'                   ');
            writexy(10,20,'                   ');
            textbackground(blue);
          end;
        end;
      end;
    end else ch := #1;
  until (ch = #13)or(ch = #27)or(play.stopped);
  if keypressed then readkey;
  closesound(actfile);
end.
