{$IFNDEF VER60}
{$A+,B+,F-,G+,I-,O+,P+,Q-,R-,S-,T-,V-,X+,Y-}
{$ELSE}
{$A+,B+,F-,G+,I-,O+,R-,S-,V-,X+}
{$ENDIF}
uses crt,soundlib{$IFDEF DPMI},winapi{$ENDIF};
type
  twavehdr = record {Header of a wavefile}
    format        : array[0..3] of char;
    filelength    : longint;
    kennstr       : array[0..7] of char;
    formatlength  : longint;
    formattag     : word;
    channels      : word;
    frequency     : longint;
    bytespersecnd : longint;
    blkalign      : word;
    resolution    : word;
    data          : array[0..3] of char;
    chunklength   : longint;
  end;

var
  h : twavehdr;

procedure recproc;far;
begin
  if rec.activeblock = 2 then
  {$IFDEF DPMI}
  blockwrite(rec.f,ptr(rec.p,0)^,rec.blocksize) else
  blockwrite(rec.f,ptr(rec.p,rec.blocksize)^,rec.blocksize);
  {$ELSE}
  blockwrite(rec.f,rec.p^,rec.blocksize) else
  blockwrite(rec.f,ptr(seg(rec.p^),ofs(rec.p^)+rec.blocksize)^,rec.blocksize);
  {$ENDIF}
  if rec.activeblock = 2 then rec.activeblock := 1 else rec.activeblock := 2;
  inc(rec.fdatasize,rec.blocksize);
end;

procedure fillheader;
begin
  h.format        := 'RIFF';
  h.filelength    := rec.fdatasize+sizeof(h);
  h.kennstr       := 'WAVEfmt ';
  h.formatlength  := 16;{Size of fmt-chunk}
  h.formattag     := 1;{normal - uncompressed}
  h.channels      := succ(byte(rec.stereo));
  h.frequency     := rec.frequency;
  h.bytespersecnd := rec.frequency*succ(byte(rec.stereo))*succ(byte(rec.sound16bit));
  h.blkalign      := succ(byte(rec.stereo))*succ(byte(rec.sound16bit));
  h.resolution    := succ(byte(rec.sound16bit))*8;
  h.data          := 'data';
  h.chunklength   := rec.fdatasize;
  blockwrite(rec.f,h,sizeof(h));
end;

var
  state : byte;

begin
  state := initblaster;
  if state <> sb_noerror then
  errorproc(state);

  if blaster.version < sb16 then begin
    writeln('Only runable on a SB16');
    halt;
  end;
  {$IFDEF DPMI}
  rec.p := globaldosalloc(16384);
  {$ELSE}
  getmem(rec.p,16384);
  {$ENDIF}
  assign(rec.f,'TEST.WAV');
  rewrite(rec.f,1);
  seek(rec.f,sizeof(h));                 {jump over header}
  {set all other channels to off..}
  setinput(linein,snd_left,off,off);
  setinput(linein,snd_right,off,off);

  setinput(midi,snd_left,off,off);
  setinput(midi,snd_right,off,off);

  setinput(mike,snd_left,off,off);
  setinput(mike,snd_right,off,off);
  {..and record only from CDplayer}
  setinput(CD,snd_left,on,off);{cd;left channel;left channel on;right channel off}
  setinput(CD,snd_right,off,on);{cd;right channel;left channel off;right channel on}
  rec.callproc := recproc;  {set procedure to call in an interrupt}
  initrecord(rec.p,16384,44100,snd_stereo+snd_16bit);
  {44100 Hz, Stereo(true), 16 bit(true)}
  write('Recording at ',rec.frequency,' Hz ');
  if rec.sound16bit then write('16 Bit ') else write('8 Bit ');
  if rec.stereo then write('Stereo') else write('Mono');
  writeln(' - Press any key to stop...');
  repeat
  until keypressed;               {until user interrupts recording}
  writeln('Recording finished');
  readkey;
  {$IFDEF DPMI}
  globaldosfree(rec.p);
  {$ELSE}
  freemem(rec.p,16384);
  {$ENDIF}
  exitrecord;
  seek(rec.f,0);                  {now jump to header}
  fillheader;                     {and write it}
  close(rec.f);
end.